
use builtin;
use str;

set edit:completion:arg-completer[pk] = {|@words|
    fn spaces {|n|
        builtin:repeat $n ' ' | str:join ''
    }
    fn cand {|text desc|
        edit:complex-candidate $text &display=$text' '(spaces (- 14 (wcswidth $text)))$desc
    }
    var command = 'pk'
    for word $words[1..-1] {
        if (str:has-prefix $word '-') {
            break
        }
        set command = $command';'$word
    }
    var completions = [
        &'pk'= {
            cand --config 'Use a custom config'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
            cand -V 'Print version'
            cand --version 'Print version'
            cand cpv 'Cpv commands'
            cand dep 'Dependency commands'
            cand pkg 'Package commands'
            cand repo 'Repository commands'
            cand version 'Version commands'
        }
        &'pk;cpv'= {
            cand --config 'Use a custom config'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
            cand compare 'Compare two cpvs'
            cand intersect 'Determine if a cpv intersects another value'
            cand parse 'Parse cpv and optionally print formatted output'
            cand set 'Collapse cpvs into a set'
            cand sort 'Sort cpvs'
        }
        &'pk;cpv;compare'= {
            cand --config 'Use a custom config'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help (see more with ''--help'')'
            cand --help 'Print help (see more with ''--help'')'
        }
        &'pk;cpv;intersect'= {
            cand --config 'Use a custom config'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'pk;cpv;parse'= {
            cand -f 'Output using a custom format'
            cand --format 'Output using a custom format'
            cand --config 'Use a custom config'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'pk;cpv;set'= {
            cand --config 'Use a custom config'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'pk;cpv;sort'= {
            cand --config 'Use a custom config'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'pk;dep'= {
            cand --config 'Use a custom config'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
            cand compare 'Compare two deps'
            cand intersect 'Determine if a dep intersects another value'
            cand parse 'Parse a dep and optionally print formatted output'
            cand set 'Collapse deps into a set'
            cand sort 'Sort deps'
        }
        &'pk;dep;compare'= {
            cand --config 'Use a custom config'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help (see more with ''--help'')'
            cand --help 'Print help (see more with ''--help'')'
        }
        &'pk;dep;intersect'= {
            cand --config 'Use a custom config'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'pk;dep;parse'= {
            cand --eapi 'Use a specific EAPI'
            cand -f 'Output using a custom format'
            cand --format 'Output using a custom format'
            cand --config 'Use a custom config'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'pk;dep;set'= {
            cand --config 'Use a custom config'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'pk;dep;sort'= {
            cand --config 'Use a custom config'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'pk;pkg'= {
            cand --config 'Use a custom config'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
            cand env 'Output ebuild environment'
            cand fetch 'Fetch distfiles'
            cand manifest 'Update manifests'
            cand metadata 'Manipulate package metadata'
            cand pretend 'Run the pkg_pretend phase'
            cand revdeps 'Output reverse dependencies'
            cand showkw 'Output package keywords'
            cand source 'Benchmark ebuild sourcing'
        }
        &'pk;pkg;env'= {
            cand -j 'Parallel jobs to run'
            cand --jobs 'Parallel jobs to run'
            cand -f 'Variable filtering'
            cand --filter 'Variable filtering'
            cand --repo 'Target repo'
            cand --config 'Use a custom config'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'pk;pkg;fetch'= {
            cand -c 'Concurrent downloads'
            cand --concurrent 'Concurrent downloads'
            cand -d 'Download directory'
            cand --dir 'Download directory'
            cand -F 'Filter URLs via regex'
            cand --filter 'Filter URLs via regex'
            cand -t 'Connection timeout in seconds'
            cand --timeout 'Connection timeout in seconds'
            cand --repo 'Target repo'
            cand --config 'Use a custom config'
            cand -f 'Overwrite existing files'
            cand --force 'Overwrite existing files'
            cand -i 'Ignore invalid service certificates'
            cand --insecure 'Ignore invalid service certificates'
            cand -m 'Try fetching from default mirrors'
            cand --mirrors 'Try fetching from default mirrors'
            cand -n 'Disable progress output'
            cand --no-progress 'Disable progress output'
            cand -p 'Output targets instead of fetching them'
            cand --pretend 'Output targets instead of fetching them'
            cand --restrict 'Process fetch-restricted URLS'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'pk;pkg;manifest'= {
            cand -c 'Concurrent downloads'
            cand --concurrent 'Concurrent downloads'
            cand -d 'Download directory'
            cand --dir 'Download directory'
            cand -t 'Connection timeout in seconds'
            cand --timeout 'Connection timeout in seconds'
            cand --repo 'Target repo'
            cand --thick 'Force manifest type'
            cand --config 'Use a custom config'
            cand -f 'Force remanifest'
            cand --force 'Force remanifest'
            cand -i 'Ignore invalid service certificates'
            cand --insecure 'Ignore invalid service certificates'
            cand -m 'Try fetching from default mirrors'
            cand --mirrors 'Try fetching from default mirrors'
            cand -n 'Disable progress output'
            cand --no-progress 'Disable progress output'
            cand --stdout 'Output to stdout'
            cand --restrict 'Process fetch-restricted URLS'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'pk;pkg;metadata'= {
            cand -j 'Parallel jobs to run'
            cand --jobs 'Parallel jobs to run'
            cand -p 'Custom cache path'
            cand --path 'Custom cache path'
            cand --format 'Custom cache format'
            cand --repo 'Target repo'
            cand --config 'Use a custom config'
            cand -f 'Force regeneration to occur'
            cand --force 'Force regeneration to occur'
            cand -V 'Verify metadata without updating cache'
            cand --verify 'Verify metadata without updating cache'
            cand -r 'Remove cache entries'
            cand --remove 'Remove cache entries'
            cand -n 'Disable progress bar'
            cand --no-progress 'Disable progress bar'
            cand -o 'Allow output to stderr and stdout (suppressed by default)'
            cand --output 'Allow output to stderr and stdout (suppressed by default)'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'pk;pkg;pretend'= {
            cand -j 'Parallel jobs to run'
            cand --jobs 'Parallel jobs to run'
            cand --repo 'Target repo'
            cand --config 'Use a custom config'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'pk;pkg;revdeps'= {
            cand -r 'Target repository'
            cand --repo 'Target repository'
            cand --config 'Use a custom config'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'pk;pkg;showkw'= {
            cand --repo 'Target repo'
            cand --config 'Use a custom config'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'pk;pkg;source'= {
            cand -j 'Parallel jobs to run (default: # of physical CPUs)'
            cand --jobs 'Parallel jobs to run (default: # of physical CPUs)'
            cand --bench 'Benchmark sourcing for a given duration per package'
            cand -b 'Bounds applied to elapsed time'
            cand --bound 'Bounds applied to elapsed time'
            cand --repo 'Target repo'
            cand --config 'Use a custom config'
            cand --sort 'Sort output in ascending order for elapsed time'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'pk;repo'= {
            cand --config 'Use a custom config'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
            cand eapi 'Output EAPI statistics'
            cand eclass 'Output eclass statistics'
            cand leaf 'Output leaf packages'
            cand license 'Output license statistics'
            cand metadata 'Manipulate repo metadata'
            cand mirror 'Output mirror statistics'
        }
        &'pk;repo;eapi'= {
            cand --eapi 'Output packages for a target EAPI'
            cand --config 'Use a custom config'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'pk;repo;eclass'= {
            cand --eclass 'Output packages for a target eclass'
            cand --config 'Use a custom config'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'pk;repo;leaf'= {
            cand --config 'Use a custom config'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'pk;repo;license'= {
            cand --license 'Output packages for a target license'
            cand --config 'Use a custom config'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'pk;repo;metadata'= {
            cand --config 'Use a custom config'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
            cand clean 'Clean metadata cache'
            cand regen 'Regenerate metadata cache'
            cand remove 'Remove metadata cache'
        }
        &'pk;repo;metadata;clean'= {
            cand -p 'Custom cache path'
            cand --path 'Custom cache path'
            cand --format 'Custom cache format'
            cand --config 'Use a custom config'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'pk;repo;metadata;regen'= {
            cand -j 'Parallel jobs to run'
            cand --jobs 'Parallel jobs to run'
            cand -p 'Custom cache path'
            cand --path 'Custom cache path'
            cand --format 'Custom cache format'
            cand --config 'Use a custom config'
            cand -f 'Force regeneration to occur'
            cand --force 'Force regeneration to occur'
            cand -n 'Disable progress bar'
            cand --no-progress 'Disable progress bar'
            cand --use-local 'Update local USE cache'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'pk;repo;metadata;remove'= {
            cand -p 'Custom cache path'
            cand --path 'Custom cache path'
            cand --format 'Custom cache format'
            cand --config 'Use a custom config'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'pk;repo;mirror'= {
            cand --mirror 'Output packages for a target mirror'
            cand --config 'Use a custom config'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'pk;version'= {
            cand --config 'Use a custom config'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
            cand compare 'Compare two versions'
            cand intersect 'Determine if two versions intersect'
            cand parse 'Parse a version and optionally print formatted output'
            cand set 'Collapse versions into a set'
            cand sort 'Sort versions'
        }
        &'pk;version;compare'= {
            cand --config 'Use a custom config'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help (see more with ''--help'')'
            cand --help 'Print help (see more with ''--help'')'
        }
        &'pk;version;intersect'= {
            cand --config 'Use a custom config'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'pk;version;parse'= {
            cand -f 'Output using a custom format'
            cand --format 'Output using a custom format'
            cand --config 'Use a custom config'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'pk;version;set'= {
            cand --config 'Use a custom config'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
        }
        &'pk;version;sort'= {
            cand --config 'Use a custom config'
            cand -v 'Increase logging verbosity'
            cand --verbose 'Increase logging verbosity'
            cand -q 'Decrease logging verbosity'
            cand --quiet 'Decrease logging verbosity'
            cand -h 'Print help'
            cand --help 'Print help'
        }
    ]
    $completions[$command]
}
